{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-unused-matches #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.Route53Domains.Types.ExtraParam
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.Route53Domains.Types.ExtraParam where

import qualified Amazonka.Core as Core
import qualified Amazonka.Core.Lens.Internal as Lens
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude
import Amazonka.Route53Domains.Types.ExtraParamName

-- | ExtraParam includes the following elements.
--
-- /See:/ 'newExtraParam' smart constructor.
data ExtraParam = ExtraParam'
  { -- | The name of an additional parameter that is required by a top-level
    -- domain. Here are the top-level domains that require additional
    -- parameters and the names of the parameters that they require:
    --
    -- [.com.au and .net.au]
    --     -   @AU_ID_NUMBER@
    --
    --     -   @AU_ID_TYPE@
    --
    --         Valid values include the following:
    --
    --         -   @ABN@ (Australian business number)
    --
    --         -   @ACN@ (Australian company number)
    --
    --         -   @TM@ (Trademark number)
    --
    -- [.ca]
    --     -   @BRAND_NUMBER@
    --
    --     -   @CA_BUSINESS_ENTITY_TYPE@
    --
    --         Valid values include the following:
    --
    --         -   @BANK@ (Bank)
    --
    --         -   @COMMERCIAL_COMPANY@ (Commercial company)
    --
    --         -   @COMPANY@ (Company)
    --
    --         -   @COOPERATION@ (Cooperation)
    --
    --         -   @COOPERATIVE@ (Cooperative)
    --
    --         -   @COOPRIX@ (Cooprix)
    --
    --         -   @CORP@ (Corporation)
    --
    --         -   @CREDIT_UNION@ (Credit union)
    --
    --         -   @FOMIA@ (Federation of mutual insurance associations)
    --
    --         -   @INC@ (Incorporated)
    --
    --         -   @LTD@ (Limited)
    --
    --         -   @LTEE@ (Limitée)
    --
    --         -   @LLC@ (Limited liability corporation)
    --
    --         -   @LLP@ (Limited liability partnership)
    --
    --         -   @LTE@ (Lte.)
    --
    --         -   @MBA@ (Mutual benefit association)
    --
    --         -   @MIC@ (Mutual insurance company)
    --
    --         -   @NFP@ (Not-for-profit corporation)
    --
    --         -   @SA@ (S.A.)
    --
    --         -   @SAVINGS_COMPANY@ (Savings company)
    --
    --         -   @SAVINGS_UNION@ (Savings union)
    --
    --         -   @SARL@ (Société à responsabilité limitée)
    --
    --         -   @TRUST@ (Trust)
    --
    --         -   @ULC@ (Unlimited liability corporation)
    --
    --     -   @CA_LEGAL_TYPE@
    --
    --         When @ContactType@ is @PERSON@, valid values include the
    --         following:
    --
    --         -   @ABO@ (Aboriginal Peoples indigenous to Canada)
    --
    --         -   @CCT@ (Canadian citizen)
    --
    --         -   @LGR@ (Legal Representative of a Canadian Citizen or
    --             Permanent Resident)
    --
    --         -   @RES@ (Permanent resident of Canada)
    --
    --         When @ContactType@ is a value other than @PERSON@, valid values
    --         include the following:
    --
    --         -   @ASS@ (Canadian unincorporated association)
    --
    --         -   @CCO@ (Canadian corporation)
    --
    --         -   @EDU@ (Canadian educational institution)
    --
    --         -   @GOV@ (Government or government entity in Canada)
    --
    --         -   @HOP@ (Canadian Hospital)
    --
    --         -   @INB@ (Indian Band recognized by the Indian Act of Canada)
    --
    --         -   @LAM@ (Canadian Library, Archive, or Museum)
    --
    --         -   @MAJ@ (Her\/His Majesty the Queen\/King)
    --
    --         -   @OMK@ (Official mark registered in Canada)
    --
    --         -   @PLT@ (Canadian Political Party)
    --
    --         -   @PRT@ (Partnership Registered in Canada)
    --
    --         -   @TDM@ (Trademark registered in Canada)
    --
    --         -   @TRD@ (Canadian Trade Union)
    --
    --         -   @TRS@ (Trust established in Canada)
    --
    -- [.es]
    --     -   @ES_IDENTIFICATION@
    --
    --         The value of @ES_IDENTIFICATION@ depends on the following
    --         values:
    --
    --         -   The value of @ES_LEGAL_FORM@
    --
    --         -   The value of @ES_IDENTIFICATION_TYPE@
    --
    --         __If @ES_LEGAL_FORM@ is any value other than @INDIVIDUAL@:__
    --
    --         -   Specify 1 letter + 8 numbers (CIF [Certificado de
    --             Identificación Fiscal])
    --
    --         -   Example: B12345678
    --
    --         __If @ES_LEGAL_FORM@ is @INDIVIDUAL@, the value that you specify
    --         for @ES_IDENTIFICATION@ depends on the value of
    --         @ES_IDENTIFICATION_TYPE@:__
    --
    --         -   If @ES_IDENTIFICATION_TYPE@ is @DNI_AND_NIF@ (for Spanish
    --             contacts):
    --
    --             -   Specify 8 numbers + 1 letter (DNI [Documento Nacional de
    --                 Identidad], NIF [Número de Identificación Fiscal])
    --
    --             -   Example: 12345678M
    --
    --         -   If @ES_IDENTIFICATION_TYPE@ is @NIE@ (for foreigners with
    --             legal residence):
    --
    --             -   Specify 1 letter + 7 numbers + 1 letter ( NIE [Número de
    --                 Identidad de Extranjero])
    --
    --             -   Example: Y1234567X
    --
    --         -   If @ES_IDENTIFICATION_TYPE@ is @OTHER@ (for contacts outside
    --             of Spain):
    --
    --             -   Specify a passport number, drivers license number, or
    --                 national identity card number
    --
    --     -   @ES_IDENTIFICATION_TYPE@
    --
    --         Valid values include the following:
    --
    --         -   @DNI_AND_NIF@ (For Spanish contacts)
    --
    --         -   @NIE@ (For foreigners with legal residence)
    --
    --         -   @OTHER@ (For contacts outside of Spain)
    --
    --     -   @ES_LEGAL_FORM@
    --
    --         Valid values include the following:
    --
    --         -   @ASSOCIATION@
    --
    --         -   @CENTRAL_GOVERNMENT_BODY@
    --
    --         -   @CIVIL_SOCIETY@
    --
    --         -   @COMMUNITY_OF_OWNERS@
    --
    --         -   @COMMUNITY_PROPERTY@
    --
    --         -   @CONSULATE@
    --
    --         -   @COOPERATIVE@
    --
    --         -   @DESIGNATION_OF_ORIGIN_SUPERVISORY_COUNCIL@
    --
    --         -   @ECONOMIC_INTEREST_GROUP@
    --
    --         -   @EMBASSY@
    --
    --         -   @ENTITY_MANAGING_NATURAL_AREAS@
    --
    --         -   @FARM_PARTNERSHIP@
    --
    --         -   @FOUNDATION@
    --
    --         -   @GENERAL_AND_LIMITED_PARTNERSHIP@
    --
    --         -   @GENERAL_PARTNERSHIP@
    --
    --         -   @INDIVIDUAL@
    --
    --         -   @LIMITED_COMPANY@
    --
    --         -   @LOCAL_AUTHORITY@
    --
    --         -   @LOCAL_PUBLIC_ENTITY@
    --
    --         -   @MUTUAL_INSURANCE_COMPANY@
    --
    --         -   @NATIONAL_PUBLIC_ENTITY@
    --
    --         -   @ORDER_OR_RELIGIOUS_INSTITUTION@
    --
    --         -   @OTHERS (Only for contacts outside of Spain)@
    --
    --         -   @POLITICAL_PARTY@
    --
    --         -   @PROFESSIONAL_ASSOCIATION@
    --
    --         -   @PUBLIC_LAW_ASSOCIATION@
    --
    --         -   @PUBLIC_LIMITED_COMPANY@
    --
    --         -   @REGIONAL_GOVERNMENT_BODY@
    --
    --         -   @REGIONAL_PUBLIC_ENTITY@
    --
    --         -   @SAVINGS_BANK@
    --
    --         -   @SPANISH_OFFICE@
    --
    --         -   @SPORTS_ASSOCIATION@
    --
    --         -   @SPORTS_FEDERATION@
    --
    --         -   @SPORTS_LIMITED_COMPANY@
    --
    --         -   @TEMPORARY_ALLIANCE_OF_ENTERPRISES@
    --
    --         -   @TRADE_UNION@
    --
    --         -   @WORKER_OWNED_COMPANY@
    --
    --         -   @WORKER_OWNED_LIMITED_COMPANY@
    --
    -- [.eu]
    --     -   @ EU_COUNTRY_OF_CITIZENSHIP@
    --
    -- [.fi]
    --     -   @BIRTH_DATE_IN_YYYY_MM_DD@
    --
    --     -   @FI_BUSINESS_NUMBER@
    --
    --     -   @FI_ID_NUMBER@
    --
    --     -   @FI_NATIONALITY@
    --
    --         Valid values include the following:
    --
    --         -   @FINNISH@
    --
    --         -   @NOT_FINNISH@
    --
    --     -   @FI_ORGANIZATION_TYPE@
    --
    --         Valid values include the following:
    --
    --         -   @COMPANY@
    --
    --         -   @CORPORATION@
    --
    --         -   @GOVERNMENT@
    --
    --         -   @INSTITUTION@
    --
    --         -   @POLITICAL_PARTY@
    --
    --         -   @PUBLIC_COMMUNITY@
    --
    --         -   @TOWNSHIP@
    --
    -- [.fr]
    --     -   @BIRTH_CITY@
    --
    --     -   @BIRTH_COUNTRY@
    --
    --     -   @BIRTH_DATE_IN_YYYY_MM_DD@
    --
    --     -   @BIRTH_DEPARTMENT@: Specify the INSEE code that corresponds with
    --         the department where the contact was born. If the contact was
    --         born somewhere other than France or its overseas departments,
    --         specify @99@. For more information, including a list of
    --         departments and the corresponding INSEE numbers, see the
    --         Wikipedia entry
    --         <https://en.wikipedia.org/wiki/Departments_of_France Departments of France>.
    --
    --     -   @BRAND_NUMBER@
    --
    -- [.it]
    --     -   @IT_NATIONALITY@
    --
    --     -   @IT_PIN@
    --
    --     -   @IT_REGISTRANT_ENTITY_TYPE@
    --
    --         Valid values include the following:
    --
    --         -   @FOREIGNERS@
    --
    --         -   @FREELANCE_WORKERS@ (Freelance workers and professionals)
    --
    --         -   @ITALIAN_COMPANIES@ (Italian companies and one-person
    --             companies)
    --
    --         -   @NON_PROFIT_ORGANIZATIONS@
    --
    --         -   @OTHER_SUBJECTS@
    --
    --         -   @PUBLIC_ORGANIZATIONS@
    --
    -- [.ru]
    --     -   @BIRTH_DATE_IN_YYYY_MM_DD@
    --
    --     -   @RU_PASSPORT_DATA@
    --
    -- [.se]
    --     -   @BIRTH_COUNTRY@
    --
    --     -   @SE_ID_NUMBER@
    --
    -- [.sg]
    --     -   @SG_ID_NUMBER@
    --
    -- [.uk, .co.uk, .me.uk, and .org.uk]
    --     -   @UK_CONTACT_TYPE@
    --
    --         Valid values include the following:
    --
    --         -   @CRC@ (UK Corporation by Royal Charter)
    --
    --         -   @FCORP@ (Non-UK Corporation)
    --
    --         -   @FIND@ (Non-UK Individual, representing self)
    --
    --         -   @FOTHER@ (Non-UK Entity that does not fit into any other
    --             category)
    --
    --         -   @GOV@ (UK Government Body)
    --
    --         -   @IND@ (UK Individual (representing self))
    --
    --         -   @IP@ (UK Industrial\/Provident Registered Company)
    --
    --         -   @LLP@ (UK Limited Liability Partnership)
    --
    --         -   @LTD@ (UK Limited Company)
    --
    --         -   @OTHER@ (UK Entity that does not fit into any other
    --             category)
    --
    --         -   @PLC@ (UK Public Limited Company)
    --
    --         -   @PTNR@ (UK Partnership)
    --
    --         -   @RCHAR@ (UK Registered Charity)
    --
    --         -   @SCH@ (UK School)
    --
    --         -   @STAT@ (UK Statutory Body)
    --
    --         -   @STRA@ (UK Sole Trader)
    --
    --     -   @UK_COMPANY_NUMBER@
    --
    -- In addition, many TLDs require a @VAT_NUMBER@.
    name :: ExtraParamName,
    -- | The value that corresponds with the name of an extra parameter.
    value :: Data.Sensitive Prelude.Text
  }
  deriving (Prelude.Eq, Prelude.Show, Prelude.Generic)

-- |
-- Create a value of 'ExtraParam' with all optional fields omitted.
--
-- Use <https://hackage.haskell.org/package/generic-lens generic-lens> or <https://hackage.haskell.org/package/optics optics> to modify other optional fields.
--
-- The following record fields are available, with the corresponding lenses provided
-- for backwards compatibility:
--
-- 'name', 'extraParam_name' - The name of an additional parameter that is required by a top-level
-- domain. Here are the top-level domains that require additional
-- parameters and the names of the parameters that they require:
--
-- [.com.au and .net.au]
--     -   @AU_ID_NUMBER@
--
--     -   @AU_ID_TYPE@
--
--         Valid values include the following:
--
--         -   @ABN@ (Australian business number)
--
--         -   @ACN@ (Australian company number)
--
--         -   @TM@ (Trademark number)
--
-- [.ca]
--     -   @BRAND_NUMBER@
--
--     -   @CA_BUSINESS_ENTITY_TYPE@
--
--         Valid values include the following:
--
--         -   @BANK@ (Bank)
--
--         -   @COMMERCIAL_COMPANY@ (Commercial company)
--
--         -   @COMPANY@ (Company)
--
--         -   @COOPERATION@ (Cooperation)
--
--         -   @COOPERATIVE@ (Cooperative)
--
--         -   @COOPRIX@ (Cooprix)
--
--         -   @CORP@ (Corporation)
--
--         -   @CREDIT_UNION@ (Credit union)
--
--         -   @FOMIA@ (Federation of mutual insurance associations)
--
--         -   @INC@ (Incorporated)
--
--         -   @LTD@ (Limited)
--
--         -   @LTEE@ (Limitée)
--
--         -   @LLC@ (Limited liability corporation)
--
--         -   @LLP@ (Limited liability partnership)
--
--         -   @LTE@ (Lte.)
--
--         -   @MBA@ (Mutual benefit association)
--
--         -   @MIC@ (Mutual insurance company)
--
--         -   @NFP@ (Not-for-profit corporation)
--
--         -   @SA@ (S.A.)
--
--         -   @SAVINGS_COMPANY@ (Savings company)
--
--         -   @SAVINGS_UNION@ (Savings union)
--
--         -   @SARL@ (Société à responsabilité limitée)
--
--         -   @TRUST@ (Trust)
--
--         -   @ULC@ (Unlimited liability corporation)
--
--     -   @CA_LEGAL_TYPE@
--
--         When @ContactType@ is @PERSON@, valid values include the
--         following:
--
--         -   @ABO@ (Aboriginal Peoples indigenous to Canada)
--
--         -   @CCT@ (Canadian citizen)
--
--         -   @LGR@ (Legal Representative of a Canadian Citizen or
--             Permanent Resident)
--
--         -   @RES@ (Permanent resident of Canada)
--
--         When @ContactType@ is a value other than @PERSON@, valid values
--         include the following:
--
--         -   @ASS@ (Canadian unincorporated association)
--
--         -   @CCO@ (Canadian corporation)
--
--         -   @EDU@ (Canadian educational institution)
--
--         -   @GOV@ (Government or government entity in Canada)
--
--         -   @HOP@ (Canadian Hospital)
--
--         -   @INB@ (Indian Band recognized by the Indian Act of Canada)
--
--         -   @LAM@ (Canadian Library, Archive, or Museum)
--
--         -   @MAJ@ (Her\/His Majesty the Queen\/King)
--
--         -   @OMK@ (Official mark registered in Canada)
--
--         -   @PLT@ (Canadian Political Party)
--
--         -   @PRT@ (Partnership Registered in Canada)
--
--         -   @TDM@ (Trademark registered in Canada)
--
--         -   @TRD@ (Canadian Trade Union)
--
--         -   @TRS@ (Trust established in Canada)
--
-- [.es]
--     -   @ES_IDENTIFICATION@
--
--         The value of @ES_IDENTIFICATION@ depends on the following
--         values:
--
--         -   The value of @ES_LEGAL_FORM@
--
--         -   The value of @ES_IDENTIFICATION_TYPE@
--
--         __If @ES_LEGAL_FORM@ is any value other than @INDIVIDUAL@:__
--
--         -   Specify 1 letter + 8 numbers (CIF [Certificado de
--             Identificación Fiscal])
--
--         -   Example: B12345678
--
--         __If @ES_LEGAL_FORM@ is @INDIVIDUAL@, the value that you specify
--         for @ES_IDENTIFICATION@ depends on the value of
--         @ES_IDENTIFICATION_TYPE@:__
--
--         -   If @ES_IDENTIFICATION_TYPE@ is @DNI_AND_NIF@ (for Spanish
--             contacts):
--
--             -   Specify 8 numbers + 1 letter (DNI [Documento Nacional de
--                 Identidad], NIF [Número de Identificación Fiscal])
--
--             -   Example: 12345678M
--
--         -   If @ES_IDENTIFICATION_TYPE@ is @NIE@ (for foreigners with
--             legal residence):
--
--             -   Specify 1 letter + 7 numbers + 1 letter ( NIE [Número de
--                 Identidad de Extranjero])
--
--             -   Example: Y1234567X
--
--         -   If @ES_IDENTIFICATION_TYPE@ is @OTHER@ (for contacts outside
--             of Spain):
--
--             -   Specify a passport number, drivers license number, or
--                 national identity card number
--
--     -   @ES_IDENTIFICATION_TYPE@
--
--         Valid values include the following:
--
--         -   @DNI_AND_NIF@ (For Spanish contacts)
--
--         -   @NIE@ (For foreigners with legal residence)
--
--         -   @OTHER@ (For contacts outside of Spain)
--
--     -   @ES_LEGAL_FORM@
--
--         Valid values include the following:
--
--         -   @ASSOCIATION@
--
--         -   @CENTRAL_GOVERNMENT_BODY@
--
--         -   @CIVIL_SOCIETY@
--
--         -   @COMMUNITY_OF_OWNERS@
--
--         -   @COMMUNITY_PROPERTY@
--
--         -   @CONSULATE@
--
--         -   @COOPERATIVE@
--
--         -   @DESIGNATION_OF_ORIGIN_SUPERVISORY_COUNCIL@
--
--         -   @ECONOMIC_INTEREST_GROUP@
--
--         -   @EMBASSY@
--
--         -   @ENTITY_MANAGING_NATURAL_AREAS@
--
--         -   @FARM_PARTNERSHIP@
--
--         -   @FOUNDATION@
--
--         -   @GENERAL_AND_LIMITED_PARTNERSHIP@
--
--         -   @GENERAL_PARTNERSHIP@
--
--         -   @INDIVIDUAL@
--
--         -   @LIMITED_COMPANY@
--
--         -   @LOCAL_AUTHORITY@
--
--         -   @LOCAL_PUBLIC_ENTITY@
--
--         -   @MUTUAL_INSURANCE_COMPANY@
--
--         -   @NATIONAL_PUBLIC_ENTITY@
--
--         -   @ORDER_OR_RELIGIOUS_INSTITUTION@
--
--         -   @OTHERS (Only for contacts outside of Spain)@
--
--         -   @POLITICAL_PARTY@
--
--         -   @PROFESSIONAL_ASSOCIATION@
--
--         -   @PUBLIC_LAW_ASSOCIATION@
--
--         -   @PUBLIC_LIMITED_COMPANY@
--
--         -   @REGIONAL_GOVERNMENT_BODY@
--
--         -   @REGIONAL_PUBLIC_ENTITY@
--
--         -   @SAVINGS_BANK@
--
--         -   @SPANISH_OFFICE@
--
--         -   @SPORTS_ASSOCIATION@
--
--         -   @SPORTS_FEDERATION@
--
--         -   @SPORTS_LIMITED_COMPANY@
--
--         -   @TEMPORARY_ALLIANCE_OF_ENTERPRISES@
--
--         -   @TRADE_UNION@
--
--         -   @WORKER_OWNED_COMPANY@
--
--         -   @WORKER_OWNED_LIMITED_COMPANY@
--
-- [.eu]
--     -   @ EU_COUNTRY_OF_CITIZENSHIP@
--
-- [.fi]
--     -   @BIRTH_DATE_IN_YYYY_MM_DD@
--
--     -   @FI_BUSINESS_NUMBER@
--
--     -   @FI_ID_NUMBER@
--
--     -   @FI_NATIONALITY@
--
--         Valid values include the following:
--
--         -   @FINNISH@
--
--         -   @NOT_FINNISH@
--
--     -   @FI_ORGANIZATION_TYPE@
--
--         Valid values include the following:
--
--         -   @COMPANY@
--
--         -   @CORPORATION@
--
--         -   @GOVERNMENT@
--
--         -   @INSTITUTION@
--
--         -   @POLITICAL_PARTY@
--
--         -   @PUBLIC_COMMUNITY@
--
--         -   @TOWNSHIP@
--
-- [.fr]
--     -   @BIRTH_CITY@
--
--     -   @BIRTH_COUNTRY@
--
--     -   @BIRTH_DATE_IN_YYYY_MM_DD@
--
--     -   @BIRTH_DEPARTMENT@: Specify the INSEE code that corresponds with
--         the department where the contact was born. If the contact was
--         born somewhere other than France or its overseas departments,
--         specify @99@. For more information, including a list of
--         departments and the corresponding INSEE numbers, see the
--         Wikipedia entry
--         <https://en.wikipedia.org/wiki/Departments_of_France Departments of France>.
--
--     -   @BRAND_NUMBER@
--
-- [.it]
--     -   @IT_NATIONALITY@
--
--     -   @IT_PIN@
--
--     -   @IT_REGISTRANT_ENTITY_TYPE@
--
--         Valid values include the following:
--
--         -   @FOREIGNERS@
--
--         -   @FREELANCE_WORKERS@ (Freelance workers and professionals)
--
--         -   @ITALIAN_COMPANIES@ (Italian companies and one-person
--             companies)
--
--         -   @NON_PROFIT_ORGANIZATIONS@
--
--         -   @OTHER_SUBJECTS@
--
--         -   @PUBLIC_ORGANIZATIONS@
--
-- [.ru]
--     -   @BIRTH_DATE_IN_YYYY_MM_DD@
--
--     -   @RU_PASSPORT_DATA@
--
-- [.se]
--     -   @BIRTH_COUNTRY@
--
--     -   @SE_ID_NUMBER@
--
-- [.sg]
--     -   @SG_ID_NUMBER@
--
-- [.uk, .co.uk, .me.uk, and .org.uk]
--     -   @UK_CONTACT_TYPE@
--
--         Valid values include the following:
--
--         -   @CRC@ (UK Corporation by Royal Charter)
--
--         -   @FCORP@ (Non-UK Corporation)
--
--         -   @FIND@ (Non-UK Individual, representing self)
--
--         -   @FOTHER@ (Non-UK Entity that does not fit into any other
--             category)
--
--         -   @GOV@ (UK Government Body)
--
--         -   @IND@ (UK Individual (representing self))
--
--         -   @IP@ (UK Industrial\/Provident Registered Company)
--
--         -   @LLP@ (UK Limited Liability Partnership)
--
--         -   @LTD@ (UK Limited Company)
--
--         -   @OTHER@ (UK Entity that does not fit into any other
--             category)
--
--         -   @PLC@ (UK Public Limited Company)
--
--         -   @PTNR@ (UK Partnership)
--
--         -   @RCHAR@ (UK Registered Charity)
--
--         -   @SCH@ (UK School)
--
--         -   @STAT@ (UK Statutory Body)
--
--         -   @STRA@ (UK Sole Trader)
--
--     -   @UK_COMPANY_NUMBER@
--
-- In addition, many TLDs require a @VAT_NUMBER@.
--
-- 'value', 'extraParam_value' - The value that corresponds with the name of an extra parameter.
newExtraParam ::
  -- | 'name'
  ExtraParamName ->
  -- | 'value'
  Prelude.Text ->
  ExtraParam
newExtraParam pName_ pValue_ =
  ExtraParam'
    { name = pName_,
      value = Data._Sensitive Lens.# pValue_
    }

-- | The name of an additional parameter that is required by a top-level
-- domain. Here are the top-level domains that require additional
-- parameters and the names of the parameters that they require:
--
-- [.com.au and .net.au]
--     -   @AU_ID_NUMBER@
--
--     -   @AU_ID_TYPE@
--
--         Valid values include the following:
--
--         -   @ABN@ (Australian business number)
--
--         -   @ACN@ (Australian company number)
--
--         -   @TM@ (Trademark number)
--
-- [.ca]
--     -   @BRAND_NUMBER@
--
--     -   @CA_BUSINESS_ENTITY_TYPE@
--
--         Valid values include the following:
--
--         -   @BANK@ (Bank)
--
--         -   @COMMERCIAL_COMPANY@ (Commercial company)
--
--         -   @COMPANY@ (Company)
--
--         -   @COOPERATION@ (Cooperation)
--
--         -   @COOPERATIVE@ (Cooperative)
--
--         -   @COOPRIX@ (Cooprix)
--
--         -   @CORP@ (Corporation)
--
--         -   @CREDIT_UNION@ (Credit union)
--
--         -   @FOMIA@ (Federation of mutual insurance associations)
--
--         -   @INC@ (Incorporated)
--
--         -   @LTD@ (Limited)
--
--         -   @LTEE@ (Limitée)
--
--         -   @LLC@ (Limited liability corporation)
--
--         -   @LLP@ (Limited liability partnership)
--
--         -   @LTE@ (Lte.)
--
--         -   @MBA@ (Mutual benefit association)
--
--         -   @MIC@ (Mutual insurance company)
--
--         -   @NFP@ (Not-for-profit corporation)
--
--         -   @SA@ (S.A.)
--
--         -   @SAVINGS_COMPANY@ (Savings company)
--
--         -   @SAVINGS_UNION@ (Savings union)
--
--         -   @SARL@ (Société à responsabilité limitée)
--
--         -   @TRUST@ (Trust)
--
--         -   @ULC@ (Unlimited liability corporation)
--
--     -   @CA_LEGAL_TYPE@
--
--         When @ContactType@ is @PERSON@, valid values include the
--         following:
--
--         -   @ABO@ (Aboriginal Peoples indigenous to Canada)
--
--         -   @CCT@ (Canadian citizen)
--
--         -   @LGR@ (Legal Representative of a Canadian Citizen or
--             Permanent Resident)
--
--         -   @RES@ (Permanent resident of Canada)
--
--         When @ContactType@ is a value other than @PERSON@, valid values
--         include the following:
--
--         -   @ASS@ (Canadian unincorporated association)
--
--         -   @CCO@ (Canadian corporation)
--
--         -   @EDU@ (Canadian educational institution)
--
--         -   @GOV@ (Government or government entity in Canada)
--
--         -   @HOP@ (Canadian Hospital)
--
--         -   @INB@ (Indian Band recognized by the Indian Act of Canada)
--
--         -   @LAM@ (Canadian Library, Archive, or Museum)
--
--         -   @MAJ@ (Her\/His Majesty the Queen\/King)
--
--         -   @OMK@ (Official mark registered in Canada)
--
--         -   @PLT@ (Canadian Political Party)
--
--         -   @PRT@ (Partnership Registered in Canada)
--
--         -   @TDM@ (Trademark registered in Canada)
--
--         -   @TRD@ (Canadian Trade Union)
--
--         -   @TRS@ (Trust established in Canada)
--
-- [.es]
--     -   @ES_IDENTIFICATION@
--
--         The value of @ES_IDENTIFICATION@ depends on the following
--         values:
--
--         -   The value of @ES_LEGAL_FORM@
--
--         -   The value of @ES_IDENTIFICATION_TYPE@
--
--         __If @ES_LEGAL_FORM@ is any value other than @INDIVIDUAL@:__
--
--         -   Specify 1 letter + 8 numbers (CIF [Certificado de
--             Identificación Fiscal])
--
--         -   Example: B12345678
--
--         __If @ES_LEGAL_FORM@ is @INDIVIDUAL@, the value that you specify
--         for @ES_IDENTIFICATION@ depends on the value of
--         @ES_IDENTIFICATION_TYPE@:__
--
--         -   If @ES_IDENTIFICATION_TYPE@ is @DNI_AND_NIF@ (for Spanish
--             contacts):
--
--             -   Specify 8 numbers + 1 letter (DNI [Documento Nacional de
--                 Identidad], NIF [Número de Identificación Fiscal])
--
--             -   Example: 12345678M
--
--         -   If @ES_IDENTIFICATION_TYPE@ is @NIE@ (for foreigners with
--             legal residence):
--
--             -   Specify 1 letter + 7 numbers + 1 letter ( NIE [Número de
--                 Identidad de Extranjero])
--
--             -   Example: Y1234567X
--
--         -   If @ES_IDENTIFICATION_TYPE@ is @OTHER@ (for contacts outside
--             of Spain):
--
--             -   Specify a passport number, drivers license number, or
--                 national identity card number
--
--     -   @ES_IDENTIFICATION_TYPE@
--
--         Valid values include the following:
--
--         -   @DNI_AND_NIF@ (For Spanish contacts)
--
--         -   @NIE@ (For foreigners with legal residence)
--
--         -   @OTHER@ (For contacts outside of Spain)
--
--     -   @ES_LEGAL_FORM@
--
--         Valid values include the following:
--
--         -   @ASSOCIATION@
--
--         -   @CENTRAL_GOVERNMENT_BODY@
--
--         -   @CIVIL_SOCIETY@
--
--         -   @COMMUNITY_OF_OWNERS@
--
--         -   @COMMUNITY_PROPERTY@
--
--         -   @CONSULATE@
--
--         -   @COOPERATIVE@
--
--         -   @DESIGNATION_OF_ORIGIN_SUPERVISORY_COUNCIL@
--
--         -   @ECONOMIC_INTEREST_GROUP@
--
--         -   @EMBASSY@
--
--         -   @ENTITY_MANAGING_NATURAL_AREAS@
--
--         -   @FARM_PARTNERSHIP@
--
--         -   @FOUNDATION@
--
--         -   @GENERAL_AND_LIMITED_PARTNERSHIP@
--
--         -   @GENERAL_PARTNERSHIP@
--
--         -   @INDIVIDUAL@
--
--         -   @LIMITED_COMPANY@
--
--         -   @LOCAL_AUTHORITY@
--
--         -   @LOCAL_PUBLIC_ENTITY@
--
--         -   @MUTUAL_INSURANCE_COMPANY@
--
--         -   @NATIONAL_PUBLIC_ENTITY@
--
--         -   @ORDER_OR_RELIGIOUS_INSTITUTION@
--
--         -   @OTHERS (Only for contacts outside of Spain)@
--
--         -   @POLITICAL_PARTY@
--
--         -   @PROFESSIONAL_ASSOCIATION@
--
--         -   @PUBLIC_LAW_ASSOCIATION@
--
--         -   @PUBLIC_LIMITED_COMPANY@
--
--         -   @REGIONAL_GOVERNMENT_BODY@
--
--         -   @REGIONAL_PUBLIC_ENTITY@
--
--         -   @SAVINGS_BANK@
--
--         -   @SPANISH_OFFICE@
--
--         -   @SPORTS_ASSOCIATION@
--
--         -   @SPORTS_FEDERATION@
--
--         -   @SPORTS_LIMITED_COMPANY@
--
--         -   @TEMPORARY_ALLIANCE_OF_ENTERPRISES@
--
--         -   @TRADE_UNION@
--
--         -   @WORKER_OWNED_COMPANY@
--
--         -   @WORKER_OWNED_LIMITED_COMPANY@
--
-- [.eu]
--     -   @ EU_COUNTRY_OF_CITIZENSHIP@
--
-- [.fi]
--     -   @BIRTH_DATE_IN_YYYY_MM_DD@
--
--     -   @FI_BUSINESS_NUMBER@
--
--     -   @FI_ID_NUMBER@
--
--     -   @FI_NATIONALITY@
--
--         Valid values include the following:
--
--         -   @FINNISH@
--
--         -   @NOT_FINNISH@
--
--     -   @FI_ORGANIZATION_TYPE@
--
--         Valid values include the following:
--
--         -   @COMPANY@
--
--         -   @CORPORATION@
--
--         -   @GOVERNMENT@
--
--         -   @INSTITUTION@
--
--         -   @POLITICAL_PARTY@
--
--         -   @PUBLIC_COMMUNITY@
--
--         -   @TOWNSHIP@
--
-- [.fr]
--     -   @BIRTH_CITY@
--
--     -   @BIRTH_COUNTRY@
--
--     -   @BIRTH_DATE_IN_YYYY_MM_DD@
--
--     -   @BIRTH_DEPARTMENT@: Specify the INSEE code that corresponds with
--         the department where the contact was born. If the contact was
--         born somewhere other than France or its overseas departments,
--         specify @99@. For more information, including a list of
--         departments and the corresponding INSEE numbers, see the
--         Wikipedia entry
--         <https://en.wikipedia.org/wiki/Departments_of_France Departments of France>.
--
--     -   @BRAND_NUMBER@
--
-- [.it]
--     -   @IT_NATIONALITY@
--
--     -   @IT_PIN@
--
--     -   @IT_REGISTRANT_ENTITY_TYPE@
--
--         Valid values include the following:
--
--         -   @FOREIGNERS@
--
--         -   @FREELANCE_WORKERS@ (Freelance workers and professionals)
--
--         -   @ITALIAN_COMPANIES@ (Italian companies and one-person
--             companies)
--
--         -   @NON_PROFIT_ORGANIZATIONS@
--
--         -   @OTHER_SUBJECTS@
--
--         -   @PUBLIC_ORGANIZATIONS@
--
-- [.ru]
--     -   @BIRTH_DATE_IN_YYYY_MM_DD@
--
--     -   @RU_PASSPORT_DATA@
--
-- [.se]
--     -   @BIRTH_COUNTRY@
--
--     -   @SE_ID_NUMBER@
--
-- [.sg]
--     -   @SG_ID_NUMBER@
--
-- [.uk, .co.uk, .me.uk, and .org.uk]
--     -   @UK_CONTACT_TYPE@
--
--         Valid values include the following:
--
--         -   @CRC@ (UK Corporation by Royal Charter)
--
--         -   @FCORP@ (Non-UK Corporation)
--
--         -   @FIND@ (Non-UK Individual, representing self)
--
--         -   @FOTHER@ (Non-UK Entity that does not fit into any other
--             category)
--
--         -   @GOV@ (UK Government Body)
--
--         -   @IND@ (UK Individual (representing self))
--
--         -   @IP@ (UK Industrial\/Provident Registered Company)
--
--         -   @LLP@ (UK Limited Liability Partnership)
--
--         -   @LTD@ (UK Limited Company)
--
--         -   @OTHER@ (UK Entity that does not fit into any other
--             category)
--
--         -   @PLC@ (UK Public Limited Company)
--
--         -   @PTNR@ (UK Partnership)
--
--         -   @RCHAR@ (UK Registered Charity)
--
--         -   @SCH@ (UK School)
--
--         -   @STAT@ (UK Statutory Body)
--
--         -   @STRA@ (UK Sole Trader)
--
--     -   @UK_COMPANY_NUMBER@
--
-- In addition, many TLDs require a @VAT_NUMBER@.
extraParam_name :: Lens.Lens' ExtraParam ExtraParamName
extraParam_name = Lens.lens (\ExtraParam' {name} -> name) (\s@ExtraParam' {} a -> s {name = a} :: ExtraParam)

-- | The value that corresponds with the name of an extra parameter.
extraParam_value :: Lens.Lens' ExtraParam Prelude.Text
extraParam_value = Lens.lens (\ExtraParam' {value} -> value) (\s@ExtraParam' {} a -> s {value = a} :: ExtraParam) Prelude.. Data._Sensitive

instance Data.FromJSON ExtraParam where
  parseJSON =
    Data.withObject
      "ExtraParam"
      ( \x ->
          ExtraParam'
            Prelude.<$> (x Data..: "Name")
            Prelude.<*> (x Data..: "Value")
      )

instance Prelude.Hashable ExtraParam where
  hashWithSalt _salt ExtraParam' {..} =
    _salt
      `Prelude.hashWithSalt` name
      `Prelude.hashWithSalt` value

instance Prelude.NFData ExtraParam where
  rnf ExtraParam' {..} =
    Prelude.rnf name `Prelude.seq` Prelude.rnf value

instance Data.ToJSON ExtraParam where
  toJSON ExtraParam' {..} =
    Data.object
      ( Prelude.catMaybes
          [ Prelude.Just ("Name" Data..= name),
            Prelude.Just ("Value" Data..= value)
          ]
      )
